diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
index 840a5abe3..456ce584e 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderDynamic.java
@@ -1,33 +1,30 @@
 package net.minecraft.client.world.chunk.provider;
 
 import com.mojang.logging.LogUtils;
-import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
-import it.unimi.dsi.fastutil.ints.IntArraySet;
-import it.unimi.dsi.fastutil.ints.IntSet;
-import net.minecraft.client.Minecraft;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.*;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.util.*;
 
-public class ChunkProviderDynamic implements IChunkProvider
-{
+public class ChunkProviderDynamic implements IChunkProvider {
     public static final int CHUNK_RADIUS = 32;
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final IntSet droppedChunksSet;
+    private final Set<ChunkPos> droppedChunksSet;
     private final Chunk emptyChunk;
-    public ChunkGenerator chunkGenerator;
-    private final IChunkLoader chunkLoader;
-    private final Int2ObjectMap<Chunk> chunkMap;
-    private final Int2ObjectMap<Chunk> forceLoadedChunkMap;
-    private final List<Chunk> forceLoadedChunkList;
-    private final World world;
+    public @Nullable ChunkGenerator chunkGenerator;
+    private final @Nullable IChunkLoader chunkLoader;
+    private final @NotNull Map<@NotNull ChunkPos, @NotNull Chunk> chunkMap;
+    private final @NotNull Map<@NotNull ChunkPos, @NotNull Chunk> forceLoadedChunkMap;
+    private final @NotNull List<Chunk> forceLoadedChunkList;
+    private final @NotNull World world;
     private int currentChunkX;
     private int currentChunkZ;
     public int forceLoadedChunksLimit = 64;
@@ -36,239 +33,207 @@ public class ChunkProviderDynamic implements IChunkProvider
     private int lastQueriedChunkZPos;
     private Chunk lastQueriedChunk;
 
-    public ChunkProviderDynamic(World world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator)
-    {
-        droppedChunksSet = new IntArraySet();
-        chunkMap = new Int2ObjectOpenHashMap<>();
-        forceLoadedChunkList = new ArrayList<>();
-        forceLoadedChunkMap = new Int2ObjectOpenHashMap<>();
-        emptyChunk = new EmptyChunk(world, 0, 0);
+    public ChunkProviderDynamic(@NotNull World world, @Nullable IChunkLoader chunkLoader, @Nullable ChunkGenerator chunkGenerator) {
+        this.droppedChunksSet = new HashSet<>();
+        this.chunkMap = new HashMap<>();
+        this.forceLoadedChunkList = new ArrayList<>();
+        this.forceLoadedChunkMap = new HashMap<>();
+        this.emptyChunk = new EmptyChunk(world, 0, 0);
         this.world = world;
         this.chunkLoader = chunkLoader;
         this.chunkGenerator = chunkGenerator;
     }
 
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ) {
-        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
-        if(canChunkBeUnloaded(chunkX, chunkZ)) {
-            if(chunkMap.containsKey(id)) droppedChunksSet.add(id);
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+
+        if (canChunkBeUnloaded(chunkPos)) {
+            if (this.chunkMap.containsKey(chunkPos)) this.droppedChunksSet.add(chunkPos);
             return false;
         }
-        Chunk chunk = chunkMap.get(id);
-        return chunk == emptyChunk || (chunk != null && chunk.isAtLocation(chunkX, chunkZ));
+        Chunk chunk = this.chunkMap.get(chunkPos);
+        return chunk == this.emptyChunk || (chunk != null && chunk.isAtLocation(chunkPos));
     }
 
-    public boolean canChunkBeUnloaded(int chunkX, int chunkZ) {
-        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
-        if(forceLoadedChunkMap.containsKey(id)) return false;
+    public boolean canChunkBeUnloaded(@NotNull ChunkPos chunkPos) {
+
+        if (this.forceLoadedChunkMap.containsKey(chunkPos)) return false;
         int renderDistance = CHUNK_RADIUS - 1;
-        return !(chunkX >= currentChunkX - renderDistance && chunkZ >= currentChunkZ - renderDistance && chunkX <= currentChunkX + renderDistance && chunkZ <= currentChunkZ + renderDistance);
+        return !(chunkPos.x >= this.currentChunkX - renderDistance && chunkPos.z >= this.currentChunkZ - renderDistance && chunkPos.x <= this.currentChunkX + renderDistance && chunkPos.z <= this.currentChunkZ + renderDistance);
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ) {
-        if(chunkX == lastQueriedChunkXPos && chunkZ == lastQueriedChunkZPos && lastQueriedChunk != null)
-        {
-            return lastQueriedChunk;
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.x == this.lastQueriedChunkXPos && chunkPos.z == this.lastQueriedChunkZPos && this.lastQueriedChunk != null) {
+            return this.lastQueriedChunk;
         }
-        if(!world.findingSpawnPoint && canChunkBeUnloaded(chunkX, chunkZ)) return emptyChunk;
-        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
-        if(!isChunkLoaded(chunkX, chunkZ)) {
-            if(chunkMap.get(id) != null){
-                Chunk chunk = chunkMap.get(id);
+        if (!this.world.findingSpawnPoint && canChunkBeUnloaded(chunkPos)) return this.emptyChunk;
+
+        if (!isChunkLoaded(chunkPos.x, chunkPos.z)) {
+            if (this.chunkMap.get(chunkPos) != null) {
+                Chunk chunk = this.chunkMap.get(chunkPos);
                 saveChunk(chunk);
                 chunk.onUnload();
             }
-            Chunk chunk = loadChunk(chunkX, chunkZ);
-            if(chunk == null)
-            {
-                if (chunkGenerator != null)
-                {
-                    chunk = chunkGenerator.generate(chunkX, chunkZ);
+            Chunk chunk = loadChunk(chunkPos.x, chunkPos.z);
+            if (chunk == null) {
+                if (this.chunkGenerator != null) {
+                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
                     chunk.fixMissingBlocks();
-                }
-                else
-                {
-                    chunk = emptyChunk;
+                } else {
+                    chunk = this.emptyChunk;
                 }
             }
-            chunkMap.put(id, chunk);
+            this.chunkMap.put(new ChunkPos(chunkPos), chunk);
+            chunk.checkForLightGaps();
             chunk.onLoad();
-            if(chunk.isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ);
+            if (chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+                populate(this, chunkPos.x, chunkPos.z);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ);
+            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+                populate(this, chunkPos.x - 1, chunkPos.z);
             }
-            if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+                populate(this, chunkPos.x, chunkPos.z - 1);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+                populate(this, chunkPos.x - 1, chunkPos.z - 1);
             }
-            if (world.getCurrentWeather() != null)
-            {
-                world.getCurrentWeather().doChunkLoadEffect(world, chunk);
+            if (this.world.getCurrentWeather() != null) {
+                this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
             }
         }
-        lastQueriedChunkXPos = chunkX;
-        lastQueriedChunkZPos = chunkZ;
-        lastQueriedChunk = chunkMap.get(id);;
-        return chunkMap.get(id);
+        this.lastQueriedChunkXPos = chunkPos.x;
+        this.lastQueriedChunkZPos = chunkPos.z;
+        this.lastQueriedChunk = this.chunkMap.get(chunkPos);
+        return this.chunkMap.get(chunkPos);
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ) {
-        return provideChunk(chunkX, chunkZ);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        return provideChunk(chunkPos, true);
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ)
-    {
-        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
-        droppedChunksSet.remove(id);
-        chunkMap.remove(id);
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+
+        this.droppedChunksSet.remove(chunkPos);
+        this.chunkMap.remove(chunkPos);
         Chunk chunk;
-        if (chunkGenerator != null)
-        {
-            chunk = chunkGenerator.generate(chunkX, chunkZ);
+        if (this.chunkGenerator != null) {
+            chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
             chunk.fixMissingBlocks();
+        } else return;
+        this.chunkMap.put(new ChunkPos(chunkPos), chunk);
+        if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x, chunkPos.z));
         }
-        else return;
-        chunkMap.put(id, chunk);
-        if(!chunk.isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ);
-        }
-        if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ);
+        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z));
         }
-        if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x, chunkPos.z - 1));
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
+            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z - 1));
         }
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ)
-    {
-        Chunk chunk = provideChunk(chunkX, chunkZ);
-        if(!chunk.isTerrainPopulated)
-        {
+    public void populate(@NotNull ChunkPos chunkPos) {
+        Chunk chunk = provideChunk(chunkPos, true);
+        if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
-            if (this.chunkGenerator != null)
-            {
+            if (this.chunkGenerator != null) {
                 this.chunkGenerator.decorate(chunk);
                 chunk.setChunkModified();
             }
         }
     }
 
-    public boolean keepLoaded(int chunkX, int chunkZ) {
-        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
-        Chunk chunk = chunkMap.get(id);
-        if(!forceLoadedChunkMap.containsKey(id) && forceLoadedChunkList.size() < forceLoadedChunksLimit) {
-            forceLoadedChunkMap.put(id, chunk);
-            forceLoadedChunkList.add(chunk);
+    public boolean keepLoaded(@NotNull ChunkPos chunkPos) {
+
+        Chunk chunk = this.chunkMap.get(chunkPos);
+        if (!this.forceLoadedChunkMap.containsKey(chunkPos) && this.forceLoadedChunkList.size() < this.forceLoadedChunksLimit) {
+            this.forceLoadedChunkMap.put(new ChunkPos(chunkPos), chunk);
+            this.forceLoadedChunkList.add(chunk);
             return true;
         }
         return false;
     }
 
-    public boolean removeFromForceLoaded(int chunkX, int chunkZ){
-        int id = ChunkCoordinate.toInt(chunkX, chunkZ);
-        forceLoadedChunkList.remove(forceLoadedChunkMap.get(id));
-        return forceLoadedChunkMap.remove(id) != null;
+    public boolean removeFromForceLoaded(@NotNull ChunkPos chunkPos) {
+        this.forceLoadedChunkList.remove(this.forceLoadedChunkMap.get(chunkPos));
+        return this.forceLoadedChunkMap.remove(chunkPos) != null;
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate)
-    {
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
         int attempts = 0;
         int chunksToBeSaved = 0;
-        if(progressUpdate != null)
-        {
-            for (Chunk chunk : chunkMap.values()) {
-                if(chunk != null && chunk.needsSaving(saveImmediately)) chunksToBeSaved++;
+        if (progressListener != null) {
+            for (Chunk chunk : this.chunkMap.values()) {
+                if (chunk.needsSaving(saveImmediately)) chunksToBeSaved++;
             }
         }
         int progress = 0;
-        for (Chunk chunk : chunkMap.values()) {
-            if(chunk == null) continue;
-            if(!chunk.needsSaving(saveImmediately)) continue;
+        for (Chunk chunk : this.chunkMap.values()) {
+            if (!chunk.needsSaving(saveImmediately)) continue;
             saveChunk(chunk);
             chunk.isModified = false;
-            if(++attempts == 2 && !saveImmediately) return false;
-            if(progressUpdate != null && ++progress % 10 == 0) progressUpdate.progressStagePercentage((progress * 100) / chunksToBeSaved);
+            if (++attempts == 2 && !saveImmediately) return false;
+            if (progressListener != null && ++progress % 10 == 0)
+                progressListener.progressStagePercentage((progress * 100) / chunksToBeSaved);
         }
         return true;
     }
 
-    private void saveChunk(Chunk chunk)
-    {
-        if(chunkLoader == null) return;
-        try
-        {
-            chunk.lastSaveTime = world.getWorldTime();
-            chunkLoader.saveChunk(world, chunk);
-        }
-        catch(IOException ioexception)
-        {
+    private void saveChunk(Chunk chunk) {
+        if (this.chunkLoader == null) return;
+        try {
+            chunk.lastSaveTime = this.world.getWorldTime();
+            this.chunkLoader.saveChunk(this.world, chunk);
+        } catch (IOException ioexception) {
             LOGGER.error("Failed to save chunk at {}, {}!", chunk.pos.x, chunk.pos.z, ioexception);
         }
     }
 
-    private Chunk loadChunk(int x, int y)
-    {
-        if(chunkLoader == null) return emptyChunk;
-        try
-        {
-            Chunk chunk = chunkLoader.loadChunk(world, x, y);
-            if(chunk != null)
-            {
-                chunk.lastSaveTime = world.getWorldTime();
+    private Chunk loadChunk(int x, int y) {
+        if (this.chunkLoader == null) return this.emptyChunk;
+        try {
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, x, y);
+            if (chunk != null) {
+                chunk.lastSaveTime = this.world.getWorldTime();
             }
             return chunk;
-        }
-        catch(Exception exception)
-        {
+        } catch (Exception exception) {
             LOGGER.error("Failed to load chunk at {}, {}!", x, y, exception);
         }
-        return emptyChunk;
+        return this.emptyChunk;
     }
 
     @Override
     public boolean tick() {
         int dropped = 0;
-        for (Chunk chunk : chunkMap.values()) {
-            if(dropped >= maxUnloadPerTick) break;
-            isChunkLoaded(chunk.pos.x, chunk.pos.z); //droppedChunksSet gets updated as side-effect
+        for (Chunk chunk : this.chunkMap.values()) {
+            if (dropped >= this.maxUnloadPerTick) break;
+            isChunkLoaded(chunk.pos); //droppedChunksSet gets updated as side-effect
         }
-        if(!droppedChunksSet.isEmpty()){
+        if (!this.droppedChunksSet.isEmpty()) {
             int unloaded = 0;
-            IntSet copy = new IntArraySet(droppedChunksSet);
-            for (int i : copy) {
-                if(unloaded >= maxUnloadPerTick) break;
-                if(forceLoadedChunkMap.containsKey(i)) continue;
-                if(chunkMap.containsKey(i)){
-                    Chunk chunk = chunkMap.get(i);
+            Set<ChunkPos> copy = new HashSet<>(this.droppedChunksSet);
+            for (ChunkPos pos : copy) {
+                if (unloaded >= this.maxUnloadPerTick) break;
+                if (this.forceLoadedChunkMap.containsKey(pos)) continue;
+                if (this.chunkMap.containsKey(pos)) {
+                    Chunk chunk = this.chunkMap.get(pos);
                     chunk.onUnload();
                     saveChunk(chunk);
-                    chunkMap.remove(i);
-                    droppedChunksSet.remove(i);
+                    this.chunkMap.remove(pos);
+                    this.droppedChunksSet.remove(pos);
                     unloaded++;
                 } else {
-                    droppedChunksSet.remove(i);
+                    this.droppedChunksSet.remove(pos);
                 }
             }
         }
@@ -280,35 +245,35 @@ public class ChunkProviderDynamic implements IChunkProvider
         return true;
     }
 
-    public IChunkLoader getChunkLoader() {
-        return chunkLoader;
+    public @Nullable IChunkLoader getChunkLoader() {
+        return this.chunkLoader;
     }
 
     @Override
-    public String getInfoString() {
-        return "Chunks: " + chunkMap.size() + ", " + "Dropped: " + droppedChunksSet.size()+", "+"Chunkloaded: "+forceLoadedChunkMap.size()+"/"+forceLoadedChunksLimit;
+    public @NotNull String getInfoString() {
+        return "Chunks: " + this.chunkMap.size() + ", " + "Dropped: " + this.droppedChunksSet.size() + ", " + "Chunkloaded: " + this.forceLoadedChunkMap.size() + "/" + this.forceLoadedChunksLimit;
     }
 
     public List<Chunk> getForceLoadedChunks() {
-        return Collections.unmodifiableList(forceLoadedChunkList);
+        return Collections.unmodifiableList(this.forceLoadedChunkList);
     }
 
     @Override
     public void unloadAllChunks() {
-        for (Chunk chunk : chunkMap.values()) {
-            if(chunk != null) chunk.onUnload();
+        for (Chunk chunk : this.chunkMap.values()) {
+            chunk.onUnload();
         }
-        chunkMap.clear();
-        droppedChunksSet.clear();
-        forceLoadedChunkMap.clear();
-        forceLoadedChunkList.clear();
-        chunkGenerator = null;
+        this.chunkMap.clear();
+        this.droppedChunksSet.clear();
+        this.forceLoadedChunkMap.clear();
+        this.forceLoadedChunkList.clear();
+        this.chunkGenerator = null;
         System.gc();
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ) {
-        currentChunkX = chunkX;
-        currentChunkZ = chunkZ;
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+        this.currentChunkX = chunkPos.x;
+        this.currentChunkZ = chunkPos.z;
     }
 }
\ No newline at end of file
